VERSION 5.00
Begin VB.Form FindForm 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Find Song"
   ClientHeight    =   3360
   ClientLeft      =   870
   ClientTop       =   3000
   ClientWidth     =   4680
   Icon            =   "FindForm.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3360
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   Begin VB.Timer Timer 
      Interval        =   250
      Left            =   3120
      Top             =   2880
   End
   Begin VB.ListBox MatchList 
      Height          =   1815
      Left            =   120
      TabIndex        =   5
      Top             =   480
      Width           =   4455
   End
   Begin VB.CommandButton CancelBtn 
      Cancel          =   -1  'True
      Caption         =   "Cancel"
      Height          =   375
      Left            =   3600
      TabIndex        =   4
      Top             =   2880
      Width           =   975
   End
   Begin VB.CommandButton OKBtn 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   3600
      TabIndex        =   3
      Top             =   2400
      Width           =   975
   End
   Begin VB.TextBox SearchWords 
      Height          =   285
      Left            =   1320
      TabIndex        =   0
      Top             =   120
      Width           =   3255
   End
   Begin VB.Label Label2 
      Caption         =   $"FindForm.frx":0442
      Height          =   855
      Left            =   120
      TabIndex        =   2
      Top             =   2400
      Width           =   3375
   End
   Begin VB.Label Label1 
      Caption         =   "Search words:"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "FindForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public SelectedSong As Long
Private ExtendedSearch As Boolean
Private WordList() As String
Private Const MaxWords = 32
Private SearchWordsChanged As Boolean

Private Sub CancelBtn_Click()
    Debug.Assert SelectedSong = 0
    Unload Me
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyUp And MatchList.ListIndex > 0 Then
        MatchList.ListIndex = MatchList.ListIndex - 1
        KeyCode = 0
    ElseIf KeyCode = vbKeyDown And MatchList.ListIndex < MatchList.ListCount - 1 Then
        MatchList.ListIndex = MatchList.ListIndex + 1
        KeyCode = 0
    End If
End Sub

Private Sub OKBtn_Click()
    If MatchList.ListIndex >= 0 Then
        SelectedSong = MatchList.ItemData(MatchList.ListIndex)
    End If
    Unload Me
End Sub

Private Sub Form_Load()
    CompileResults
    SelectedSong = 0
End Sub

Sub CompileResults()
    Dim N As Long
    
    MatchList.Clear
    If SearchWords.Text = "" Then Exit Sub
    
    ' Build the WordList array from the text the user has typed
    ParseWords SearchWords.Text
    If UBound(WordList) = 0 Then Exit Sub
    
    For N = 1 To UBound(Lyrics)
        ' Determine text to search in
        Dim FullText As String
        FullText = Lyrics(N).Artist & " " & Lyrics(N).Title
        If ExtendedSearch Then
            FullText = FullText & Lyrics(N).Album & " " & Lyrics(N).Comment & " " & Lyrics(N).Lyrics
        End If
        
        If DoWordSearch(FullText) Then
            ' All words matched!  Add song to the match list.
            AddSongToMatchList N
        End If
    Next
End Sub

Function DoWordSearch(ByRef What As String) As Boolean
    Dim N As Long, Pos As Long, Ch1 As String

    ' Search for each word in the word list
    For N = 1 To UBound(WordList)
        Pos = 0
        Do
            Pos = InStr(Pos + 1, What, WordList(N), 1)
            If Pos > 0 Then
                ' Word found in What, but was the start of a word?
                If Pos = 1 Then Ch1 = "" Else Ch1 = UCase(Mid(What, Pos - 1, 1))
                If (Ch1 >= "A" And Ch1 <= "Z") Then
                    ' A character to the left or right was alphabetic, so no match.
                Else ' Match!
                    Exit Do
                End If
            Else
                ' Word not found; return False
                Exit Function
            End If
        Loop
    Next
    ' All words have been found; return true
    DoWordSearch = True
End Function

Sub ParseWords(Words As String)
    Dim C As String
    Dim InWord As Boolean, InQuote As Boolean
    Dim i As Integer, NumWords As Integer
    ReDim WordList(MaxWords) As String
    ExtendedSearch = False
    NumWords = 0: InWord = False
    'Go thru Words string one character at a time.
    For i = 1 To Len(Words)
        C = Mid(Words, i, 1)
        If C = "*" And Not InQuote Then
            ExtendedSearch = True
        ElseIf InQuote Or (C <> " " And C <> vbTab) Then
            ' Neither space nor tab, or in a quoted area of text
            If Not InWord Then ' Start new word if not in one already
                ' New word begins
                If NumWords = MaxWords Then Exit For
                NumWords = NumWords + 1
                InWord = True
            End If
            'Add character to current argument.
            WordList(NumWords) = WordList(NumWords) & C
            If C = Chr(34) Then InQuote = Not InQuote
        Else
            'Found a space or tab.
            'Set InWord flag to False.
            InWord = False
        End If
    Next i
    ' Remove quotes from words
    Dim Pos As Integer
    For i = 1 To NumWords
        Do
            Pos = InStr(WordList(i), Chr(34))
            If Pos = 0 Then Exit Do
            WordList(i) = Left(WordList(i), Pos - 1) + Mid(WordList(i), Pos + 1)
        Loop
    Next
    ' Remove short words if using extended search
    If ExtendedSearch Then
        For i = NumWords To 1 Step -1
            If Len(WordList(i)) <= 2 Then
                ' Collapse array
                Dim I2 As Long
                For I2 = i To NumWords - 1
                    WordList(I2) = WordList(I2 + 1)
                Next
                NumWords = NumWords - 1
            End If
        Next
    End If
    ' Resize array just enough to hold words.
    ReDim Preserve WordList(NumWords) As String
End Sub

Sub AddSongToMatchList(Index As Long)
    MatchList.AddItem Lyrics(Index).Artist & " - " & Lyrics(Index).Title, MatchList.ListCount
    MatchList.ItemData(MatchList.ListCount - 1) = Index
End Sub

Private Sub SearchWords_Change()
    SearchWordsChanged = True
End Sub

Private Sub Timer_Timer()
    If SearchWordsChanged Then
        CompileResults
        If MatchList.ListCount > 0 Then MatchList.ListIndex = 0
        SearchWordsChanged = False
    End If
End Sub

Private Sub MatchList_DblClick()
    OKBtn_Click
End Sub

