Attribute VB_Name = "Module"
Public Lyrics() As Lyric

Type CtlPosInfo ' Used to store relative control position
                ' information in the OrderForm
    Control As Control
    Section As Integer
    AnchorX As Integer ' Specifies the type of anchoring for
    AnchorY As Integer '   the control to attach to the section
    X As Long          ' Meaning depends on anchor type:
    Y As Long          '   ALeft/AStretch: Position relative to left/top
                       '   ARight: Position relative to right/bottom (positive)
    WidthAdj As Long   ' Negative value indicating width and
    HeightAdj As Long  '   height relative to section (AStretch only)
End Type

Public Const ALeft As Integer = 0    ' Anchor to left side
Public Const ATop As Integer = 0     ' Anchor to top
Public Const ARight As Integer = 1   ' Anchor to right side
Public Const ABottom As Integer = 1  ' Anchor to bottom
Public Const AStretch As Integer = 2 ' Anchor to both (by stretching)

Type Rect
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Public AppTitle As String

Sub Main()
    AppTitle = App.Title
    Dim Args: Args = GetCommandLine
    Dim FileToLoad As String
    For N = 1 To UBound(Args)
        If Left(Args(N), 1) = "-" Then
            ' Switches
        Else
            ' Load a specific file
            FileToLoad = Args(N)
        End If
    Next
    LyricForm.Show
    If FileToLoad <> "" Then
        ReDim Lyrics(0) As Lyric
        LyricForm.LoadFile FileToLoad
    End If
End Sub
