VERSION 5.00
Begin VB.Form SuperMsgBox 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Message Box"
   ClientHeight    =   1455
   ClientLeft      =   3090
   ClientTop       =   570
   ClientWidth     =   4680
   Icon            =   "SMsgBox.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1455
   ScaleWidth      =   4680
   ShowInTaskbar   =   0   'False
   Begin VB.CommandButton Button 
      Caption         =   "Button"
      Height          =   375
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   960
      Width           =   1095
   End
   Begin VB.Label Text 
      AutoSize        =   -1  'True
      Caption         =   "Text"
      Height          =   195
      Left            =   120
      TabIndex        =   0
      Top             =   120
      UseMnemonic     =   0   'False
      Width           =   4515
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "SuperMsgBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public ButtonWidth As Long, ButtonHeight As Long
Private ButtonCount As Integer
Private DefButton As Integer, UserChoice As Integer

Function Exec(Prompt As String, Buttons As String, Optional Flags As Long, Optional Title As String, Optional CancelButton As Integer = 0)
    ' Shows the SuperMessageBox.
    ' N.B. Closing the window without clicking a button causes
    '    the the default button to be returned.
    ' Buttons format: name of each button separated by "|"
    ' This function does not set ButtonWidth
    
    ' Determine default button
    Dim DefBtn As Long: DefBtn = (Flags And vbDefaultButton4)
    Select Case DefBtn
    Case vbDefaultButton1: DefButton = 1
    Case vbDefaultButton2: DefButton = 2
    Case vbDefaultButton3: DefButton = 3
    Case vbDefaultButton4: DefButton = 4
    End Select

    Debug.Assert Buttons <> ""
    ' Parse & set up buttons
    Dim N As Long, NextButton As String, Pos As Long, LastPos As Long
    Pos = 0: N = 0
    Do
        LastPos = Pos
        Pos = InStr(Pos + 1, Buttons, "|")
        If Pos = 0 Then
            NextButton = Mid(Buttons, LastPos + 1)
        Else
            NextButton = Mid(Buttons, LastPos + 1, Pos - LastPos - 1)
        End If
        
        N = N + 1
        If N > Button.UBound Then Load Button(N)
        Button(N).Visible = True
        Button(N).Default = (N = DefButton)
        Button(N).Cancel = (N = CancelButton)
        Button(N).Caption = NextButton
        
    Loop While Pos > 0
    ButtonCount = N
    
    If Title = "" Then Caption = App.Title Else Caption = Title
    Text.Caption = Prompt
    SetupPositioning
    CenterWindow
    
    Debug.Assert DefButton > 0 And DefButton < ButtonCount
    Visible = True
    Button(DefButton).SetFocus
    Visible = False
    
    Show 1
    Exec = UserChoice
End Function

Private Sub Button_Click(Index As Integer)
    UserChoice = Index
    Unload Me
End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)
    Dim N As Long, Pos As Long
    If KeyAscii = Asc("&") Then Exit Sub
    For N = 1 To Button.UBound
        If Button(N).Enabled Then
            Pos = 0
            Do
                Pos = InStr(Pos + 1, Button(N).Caption, "&")
                If Pos = 0 Then Exit Do
                If UCase(Mid(Button(N).Caption, Pos + 1, 1)) = UCase(Chr(KeyAscii)) Then
                    Button(N).Value = True ' Invoke click event
                    Exit For
                End If
            Loop
        End If
    Next
End Sub

Sub SetupPositioning()
    If ButtonWidth = 0 Then ButtonWidth = 1095
    If ButtonHeight = 0 Then ButtonHeight = 375
    
    ' Determine the minimum and maximum possible widths for the message box.
    Dim MinW As Long, MaxW As Long, W As Long
    MinW = (ButtonWidth + 120) * ButtonCount - 120
    MaxW = 9240 ' Maximum with, a little under under 640 pixels
    If MinW > MaxW Then MinW = MaxW

    ' I'm not sure how to figure out what the width should be.
    ' So, I'll wing it.
    Dim MinH As Long, MaxH As Long, RelativeH As Double
    Text.Width = MaxW: MinH = Text.Height
    Text.Width = MinW: MaxH = Text.Height
    If MaxH = 0 Then
        RelativeH = 1
    Else
        RelativeH = MinH / MaxH
    End If
    W = MinW * RelativeH + MaxW * (1 - RelativeH)
    
    Text.Width = W
    Width = (Width - ScaleWidth) + W + 240
    
    Dim ButtonMargin As Long, N As Integer
    ButtonMargin = (W - MinW + 240) / 2
    For N = 1 To ButtonCount
        Button(N).Width = ButtonWidth
        Button(N).Height = ButtonHeight
        Button(N).Left = ButtonMargin + (N - 1) * (ButtonWidth + 120)
        Button(N).Top = Text.Height + 360
    Next
    
    Height = (Height - ScaleHeight) + Button(1).Top + Button(1).Height + 120
End Sub

Sub CenterWindow()
    Left = (Screen.Width - Width) / 2
    Top = (Screen.Height - Height) / 2
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    If UnloadMode <> vbFormCode Then
        UserChoice = DefButton
    End If
End Sub
