Attribute VB_Name = "Utils"
Option Explicit
' Utility routines
Const MaxCmdLineArgs = 32

Function GetCommandLine() As Variant
    Dim C As String, CmdLine As String, CmdLnLen As Integer
    Dim InArg As Boolean, InQuote As Boolean, i As Integer, NumArgs As Integer
    ReDim ArgArray(MaxCmdLineArgs) As String
    NumArgs = 0: InArg = False
    'Get command line arguments.
    CmdLine = Command()
    CmdLnLen = Len(CmdLine)
    'Go thru command line one character at a time.
    For i = 1 To CmdLnLen
        C = Mid(CmdLine, i, 1)
        If InQuote Or (C <> " " And C <> vbTab) Then
            ' Neither space nor tab, or in a quoted area of command line
            If Not InArg Then ' Start new arg if not in one already
                'New argument begins
                If NumArgs = MaxCmdLineArgs Then Exit For
                NumArgs = NumArgs + 1
                InArg = True
            End If
            'Add character to current argument.
            ArgArray(NumArgs) = ArgArray(NumArgs) & C
            If C = Chr(34) Then InQuote = Not InQuote
        Else
            'Found a space or tab.
            'Set InArg flag to False.
            InArg = False
        End If
    Next i
    'Resize array just enough to hold arguments.
    ReDim Preserve ArgArray(NumArgs) As String
    ' Remove quotes in arguments
    Dim Pos As Integer
    For i = 1 To NumArgs
        Do
            Pos = InStr(ArgArray(i), Chr(34))
            If Pos = 0 Then Exit Do
            ArgArray(i) = Left(ArgArray(i), Pos - 1) + Mid(ArgArray(i), Pos + 1)
        Loop
    Next
    GetCommandLine = ArgArray()
End Function

Function InstrNonSlashed(S As String, SubStr As String, Optional ByVal N As Long = 1) As Long
    ' Finds the first SubStr in S that is not preceded by "\"
    ' N = Starting position for search
    Do
        N = InStr(N, S, SubStr)
        If N = 0 Then InstrNonSlashed = 0: Exit Function
        If N = 1 Then InstrNonSlashed = 1: Exit Function
        If Mid(S, N - 1, 1) <> "\" Then InstrNonSlashed = N: Exit Function
        N = N + 1
    Loop
End Function

Sub EmbedBackslashes(S As String, ByVal BadChars As String)
    ' The first 'Bad character' must always be the backslash itself.
    ' Because the backslash is prepended here, the caller must not
    ' include the backslash in the BadChars string.
    Debug.Assert InStr(BadChars, "\") = 0
    BadChars = "\" & BadChars
    Dim N As Long, N2
    For N2 = 1 To Len(BadChars)
        N = 1
        Do
            N = InStr(N, S, Mid(BadChars, N2, 1))
            If N = 0 Then Exit Do
            S = Left(S, N - 1) & "\" & Mid(S, N)
            N = N + 2
        Loop
    Next
End Sub

Sub StripBackslashes(S As String)
    Dim N As Long: N = 1
    Do
        N = InStr(N, S, "\")
        If N = 0 Then Exit Do
        S = Left(S, N - 1) & Mid(S, N + 1)
        N = N + 1
    Loop
End Sub
